//+------------------------------------------------------------------+
//|                                                Mathematician.mq4 |
//|                              Copyright 2015, dj_ermoloff@mail.ru |
//|                               dj_ermoloff@mail.ru |
//+------------------------------------------------------------------+
#property copyright "      : dj_ermoloff@mail.ru"
#property link      "mailto:dj_ermoloff@mail.ru"
#property version   "1.00"
#property strict

extern int EMA = 8;
extern int MACD_Fast = 12;
extern int MACD_Slow = 26;
extern int MACD_Signal = 9;
extern int Min_Body = 10;
extern int StopLoss = 55;
extern int TakeProfit = 95;
extern int Close_H4_Bar = 1;
extern string s4 = " ";
extern double Lot = 0.1;
extern double Risk = 3;
extern int slippage = 0;
extern int MagicNumber = 946304868;
extern string comment = "";

double op,sl,tp,tr,tr_1,l;
int it_buy,it_sell,k_8,err;

//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   if (MarketInfo(Symbol(),MODE_DIGITS) == 5 || MarketInfo(Symbol(),MODE_DIGITS) == 3)
      k_8 = 10;
     else
      k_8 = 1;
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
   double ma = iMA(Symbol(),PERIOD_H4,EMA,0,MODE_EMA,PRICE_CLOSE,1);
   double macd_1 = iMACD(Symbol(),PERIOD_H4,MACD_Fast,MACD_Slow,MACD_Signal,PRICE_CLOSE,MODE_MAIN,1);
   double macd_2 = iMACD(Symbol(),PERIOD_H4,MACD_Fast,MACD_Slow,MACD_Signal,PRICE_CLOSE,MODE_MAIN,2);
   
   int buy = 0;
   int sell = 0;
   int buystop = 0;
   int sellstop = 0;

   for (int pos=0;pos<OrdersTotal();pos++)
      {
      if (OrderSelect(pos,SELECT_BY_POS,MODE_TRADES)==true)
         {
         if (OrderMagicNumber()==MagicNumber && OrderSymbol() == Symbol())
            {
            if (OrderType() == OP_BUY)
               {
               buy++;
               
               if (OrderOpenTime() + Close_H4_Bar * 14400 <= TimeCurrent()) OrderClose(OrderTicket(),OrderLots(),Bid,slippage,Blue);
               }
               
            if (OrderType() == OP_SELL)
               {
               sell++;
               if (OrderOpenTime() + Close_H4_Bar * 14400 <= TimeCurrent()) OrderClose(OrderTicket(),OrderLots(),Ask,slippage,Blue);
               }
               
            if (OrderType() == OP_BUYSTOP)
               {
               buystop++;
               }
               
            if (OrderType() == OP_SELLSTOP)
               {
               sellstop++;
               }
            }
         }
      }
      
   if (it_buy != iTime(Symbol(),PERIOD_H4,0) && buy == 0 && buystop == 0)
      {
      if (TimeHour(TimeCurrent()) == 8 && (iClose(Symbol(),PERIOD_H4,1) - iOpen(Symbol(),PERIOD_H4,1)) > Min_Body * k_8 * Point && iClose(Symbol(),PERIOD_H4,1) > ma && macd_1 > macd_2)
         {
         op = NormalizeDouble(Ask,Digits);
         if (StopLoss > 0) sl = NormalizeDouble(op - StopLoss * k_8 * Point,Digits); else sl = 0;
         if (TakeProfit > 0) tp = NormalizeDouble(op + TakeProfit * k_8 * Point,Digits); else tp = 0;
         
         if ((StopLoss == 0 || op - sl > MarketInfo(Symbol(),MODE_STOPLEVEL)*Point) && (TakeProfit == 0 || tp - op > MarketInfo(Symbol(),MODE_STOPLEVEL)*Point))
            {
            OrderSend(Symbol(),OP_BUY,get_lot(MathAbs(op-sl)),op,slippage,sl,tp,comment,MagicNumber,0,Green);
            err = GetLastError();
            if (err != 0) Print(" BUY ",err," op=",op," sl=",sl," tp=",tp); else it_buy = iTime(Symbol(),PERIOD_H4,0);
            }
         }
      }
      
   if (it_sell != iTime(Symbol(),PERIOD_H4,0) && sell == 0 && sellstop == 0)
      {
      if (TimeHour(TimeCurrent()) == 8 && (iOpen(Symbol(),PERIOD_H4,1)-iClose(Symbol(),PERIOD_H4,1)) > Min_Body * k_8 * Point && iClose(Symbol(),PERIOD_H4,1) < ma && macd_1 < macd_2)
         {
         op = NormalizeDouble(Bid,Digits);
         if (StopLoss > 0) sl = NormalizeDouble(op + StopLoss * k_8 * Point,Digits); else sl = 0;
         if (TakeProfit > 0) tp = NormalizeDouble(op - TakeProfit * k_8 * Point,Digits); else tp = 0;
         
         if ((StopLoss == 0 || sl - op > MarketInfo(Symbol(),MODE_STOPLEVEL)*Point) && (TakeProfit == 0 || op - tp > MarketInfo(Symbol(),MODE_STOPLEVEL)*Point))
            {
            OrderSend(Symbol(),OP_SELL,get_lot(MathAbs(op-sl)),op,slippage,sl,tp,comment,MagicNumber,0,Red);
            err = GetLastError();
            if (err != 0) Print(" SELL ",err," op=",op," sl=",sl," tp=",tp); else it_sell = iTime(Symbol(),PERIOD_H4,0);
            }
         }
      }
  }
//+------------------------------------------------------------------+

double get_lot (double s)
   {
   double b = AccountBalance();
   double l = Lot;
   int k = 1;
   
   if (Lot == 0)
      {
      l = b * Risk / (s * MarketInfo(Symbol(),MODE_LOTSIZE)*100);
      }
   return(norm_l(l));
   }
   
double norm_l (double l)
   {
   l = MathRound(l / MarketInfo(Symbol(),MODE_LOTSTEP)) * MarketInfo(Symbol(),MODE_LOTSTEP);
   if (l > MarketInfo(Symbol(),MODE_MAXLOT))
      l = MarketInfo(Symbol(),MODE_MAXLOT);
   if (l < MarketInfo(Symbol(),MODE_MINLOT))
      l = MarketInfo(Symbol(),MODE_MINLOT);
   return(l);
   }